using System.Numerics;
using Nethereum.ABI.FunctionEncoding.Attributes;
using Nethereum.Contracts;
using HexBigInteger = Nethereum.Hex.HexTypes.HexBigInteger;

namespace Frontend.Functions;
[Function("exactInputSingle")]
public class SwapExactInputSingleFunction : FunctionMessage
{
    [Parameter("address", "tokenIn")]
    public string TokenIn { get; set; }

    [Parameter("address", "tokenOut")]
    public string TokenOut { get; set; }

    [Parameter("uint24", "fee")]
    public BigInteger Fee { get; set; }

    [Parameter("address", "recipient")]
    public string Recipient { get; set; }

    [Parameter("uint256", "amountIn")]
    public BigInteger AmountIn { get; set; }

    [Parameter("uint256", "amountOutMinimum")]
    public BigInteger AmountOutMinimum { get; set; }

    [Parameter("uint160", "sqrtPriceLimitX96")]
    public BigInteger SqrtPriceLimitX96 { get; set; }
        [Parameter("uint256", "deadline")]
    public BigInteger Deadline { get; set; }
}